---
title: WEBGL_draw_buffers.drawBuffersWEBGL()
slug: Web/API/WEBGL_draw_buffers/drawBuffersWEBGL
tags:
  - API
  - Method
  - Reference
  - WebGL
---
<div>{{APIRef("WebGL")}}</div>

<p>The <code><strong>WEBGL_draw_buffers.drawBuffersWEBGL()</strong></code> method is part of the <a href="/en-US/docs/Web/API/WebGL_API">WebGL API</a> and allows you to define the draw buffers to which all fragment colors are written.</p>

<p>This method is part of the {{domxref("WEBGL_draw_buffers")}} extension.</p>

<div class="note">
<p><strong>Note:</strong> When using {{domxref("WebGL2RenderingContext", "WebGL2")}}, this method is available as {{domxref("WebGL2RenderingContext.drawBuffers()", "gl.drawBuffers()")}} by default and the constants are named <code>gl.COLOR_ATTACHMENT1</code> etc. without the "WEBGL" suffix.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">void gl.getExtension('WEBGL_draw_buffers').drawBuffersWEBGL(buffers);</pre>

<h3 id="Parameters">Parameters</h3>

<ul>
</ul>

<dl>
 <dt>buffers</dt>
 <dd>An {{jsxref("Array")}} of {{domxref("GLenum")}} constants defining drawing buffers. Possible values:
 <ul>
  <li><code>gl.NONE</code>: The fragment shader is not written to any color buffer.</li>
  <li><code>gl.BACK</code>: The fragment shader is written to the back color buffer.</li>
  <li><code>ext.COLOR_ATTACHMENT0_WEBGL</code> The fragment shader is written the <em>n</em>th color attachment of the framebuffer.</li>
  <li><code>ext.COLOR_ATTACHMENT1_WEBGL</code></li>
  <li><code>ext.COLOR_ATTACHMENT2_WEBGL</code></li>
  <li><code>ext.COLOR_ATTACHMENT3_WEBGL</code></li>
  <li><code>ext.COLOR_ATTACHMENT4_WEBGL</code></li>
  <li><code>ext.COLOR_ATTACHMENT5_WEBGL</code></li>
  <li><code>ext.COLOR_ATTACHMENT6_WEBGL</code></li>
  <li><code>ext.COLOR_ATTACHMENT7_WEBGL</code></li>
  <li><code>ext.COLOR_ATTACHMENT8_WEBGL</code></li>
  <li><code>ext.COLOR_ATTACHMENT9_WEBGL</code></li>
  <li><code>ext.COLOR_ATTACHMENT10_WEBGL</code></li>
  <li><code>ext.COLOR_ATTACHMENT11_WEBGL</code></li>
  <li><code>ext.COLOR_ATTACHMENT12_WEBGL</code></li>
  <li><code>ext.COLOR_ATTACHMENT13_WEBGL</code></li>
  <li><code>ext.COLOR_ATTACHMENT14_WEBGL</code></li>
  <li><code>ext.COLOR_ATTACHMENT15_WEBGL</code></li>
 </ul>
 </dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>None.</p>

<h2 id="Examples">Examples</h2>

<p>See {{domxref("WEBGL_draw_buffers")}} for more context with this example code.</p>

<pre class="brush: js">ext.drawBuffersWEBGL([
  ext.COLOR_ATTACHMENT0_WEBGL, // gl_FragData[0]
  ext.COLOR_ATTACHMENT1_WEBGL, // gl_FragData[1]
  ext.COLOR_ATTACHMENT2_WEBGL, // gl_FragData[2]
  ext.COLOR_ATTACHMENT3_WEBGL  // gl_FragData[3]
]);</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WEBGL_draw_buffers', '', 'WEBGL_draw_buffers')}}</td>
   <td>{{Spec2('WEBGL_draw_buffers')}}</td>
   <td>Initial definition.</td>
  </tr>
  <tr>
   <td>{{SpecName('OpenGL ES 3.0', 'glDrawBuffers.xhtml', 'glDrawBuffers')}}</td>
   <td>{{Spec2('OpenGL ES 2.0')}}</td>
   <td>Man page of the (similar) OpenGL API.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.WEBGL_draw_buffers.drawBuffersWEBGL")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("WEBGL_draw_buffers")}}</li>
 <li>{{domxref("WebGLRenderingContext.getExtension()")}}</li>
 <li>{{domxref("WebGLRenderingContext.framebufferRenderbuffer()")}},</li>
 <li>{{domxref("WebGLRenderingContext.framebufferTexture2D()")}},</li>
 <li>{{domxref("WebGLRenderingContext.getFramebufferAttachmentParameter()")}} </li>
 <li>{{domxref("WebGLRenderingContext.getParameter()")}}</li>
 <li><a href="https://hacks.mozilla.org/2014/01/webgl-deferred-shading/">WebGL deferred shading - Mozilla Hacks blog</a></li>
</ul>
